/**************************************************
 *
 * IFF2.c
 *
 *    Code to deal with misc. IFF chunk types
 *
 *    Copyright(c), 1990 Lloyd B. Eldred
 *                     & Fredrick R Homan
 **************************************************/
#include <stdio.h>
#include <math.h>
#include "fi_IFF.h"

extern UBYTE VERBOSE, TERSE,COMMENT;  /* Yuck, global variables... */

void IFF_FTXT(picfile,size)   
FILE *picfile;
LONG size; 

{
   printf(" FTXT (Formatted Text)\n");
   IFF_GotoEnd(picfile,size);   
}

void IFF_CHRS(picfile,size)   
FILE *picfile;
LONG size; 

{
   if(VERBOSE) printf(" CHRS chunk (8-bit character stream)\n");
   IFF_GotoEnd(picfile,size);   
}

void IFF_FONS(picfile,size)   
FILE *picfile;
LONG size; 

{
   if(VERBOSE) printf(" FONS chunk (Font specification)\n");
   IFF_GotoEnd(picfile,size);   
}

void IFF_AIFF(picfile,size)   
FILE *picfile;
LONG size; 

{
   if(VERBOSE) printf(" AIFF (Apple Audio IFF)\n");
   IFF_GotoEnd(picfile,size);   
}


void IFF_BANK(picfile,size)   
FILE *picfile;
LONG size; 

{
	if(VERBOSE) printf(" BANK (SoundQuest MIDI data-dump)\n");
   IFF_GotoEnd(picfile,size);   
}

void IFF_HEAD(picfile,size)   
FILE *picfile;
LONG size; 

{
   printf(" HEAD (Flow Idea Processor form)\n");
   IFF_GotoEnd(picfile,size);   
}

void IFF_MIDI(picfile,size)   
FILE *picfile;
LONG size; 

{
   if(VERBOSE) printf(" MIDI\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_PGTB(picfile,size)   
FILE *picfile;
LONG size; 

{
   printf(" PGTB (ProGram TraceBack diagnostic dump image)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_SYTH(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" SYTH (SoundQuest Master Librarian file)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_WORD(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" WORD (ProWrite data file)\n");
   IFF_GotoEnd(picfile,size);   
   
}
		
void IFF_C100(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" C100 (Cloanto Italia, private word processing form)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_PDEF(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" PDEF (Deluxe Print page definition)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_SHAK(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" SHAK (Shakespeare data file)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_VDEO(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" VDEO (Deluxe Video chunk)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_SAMP(picfile,size)   
FILE *picfile;
LONG size; 

{
  	printf(" SAMP (Sound Sample Chunk)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_TDDD(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" TDDD (Turbo Silver chunk)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_SC3D(picfile,size)   
FILE *picfile;
LONG size; 

{
   printf(" SC3D (Sculpt 3-D chunk)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_TEXT(picfile,size)   
FILE *picfile;
LONG size; 

{
   printf(" TEXT (unformatted ASCII text chunk)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_FNTR(picfile,size)   
FILE *picfile;
LONG size; 

{
	if(VERBOSE) printf(" FNTR (Raster Font chunk)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_FNTV(picfile,size)   
FILE *picfile;
LONG size; 

{
	if(VERBOSE) printf(" FNTV (Vector Font Chunk)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_GSCR(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" GSCR (General-use musical SCoRe Chunk)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_PICS(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" PICS (Macintosh picture)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_PLBM(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" PLBM (Obsolete)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_USCR(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" USCR (Uhura Sound software musical score)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_UVOX(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" UVOX (Uhura Sound software Macintosh Voice)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_CLIP(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" CLIP (Clipboard data)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_ARC(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" ARC  (Archive form)\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_ATXT(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" ATXT\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_PTXT(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" PTXT\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_RGBX(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" RGBX\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_CDAT(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" CDAT\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_MSMP(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" MSMP\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_FIGR(picfile,size)   
FILE *picfile;
LONG size; 

{  
	printf(" FIGR\n");
   IFF_GotoEnd(picfile,size);   
   
}

void IFF_MOVI(picfile,size)   
FILE *picfile;
LONG size; 

{
	printf(" MOVI\n");
   IFF_GotoEnd(picfile,size);   
   
}
